/*
 * File:   oritentacaoMao.cpp
 * Author: danilo
 *
 * Created on 22 de Setembro de 2010, 17:00
 */

#include "orientacaoMao.h"
#include <string>
#include <iostream>
#include <string.h>

using namespace std;

OrientacaoMao::OrientacaoMao() {

}

string OrientacaoMao::getOrientacaoPalmaMao(string orientacao, string direcaoPalmaMao, string orientacaoPontaDedos) {
    if (orientacao.compare("paralelo-ao-solo") == 0) {
        if (direcaoPalmaMao.compare("para-cima") == 0) {
            if (orientacaoPontaDedos.compare("para-frente") == 0) {
                return "Ori_6";
            }
            if (orientacaoPontaDedos.compare("para-dentro") == 0) { //v
                return "Ori_12";
            }
        }
        if (direcaoPalmaMao.compare("para-dentro") == 0) {
            if (orientacaoPontaDedos.compare("para-frente") == 0) {
                return "Ori_5";
            }            
        }
        if ((direcaoPalmaMao.compare("para-baixo") == 0)) {
            if (orientacaoPontaDedos.compare("para-frente") == 0) {
                return "Ori_4";
            }
            if (orientacaoPontaDedos.compare("para-dentro") == 0) { //v
                return "Ori_10";
            }
        }
        if (direcaoPalmaMao.compare("para-tras") == 0) {
            if (orientacaoPontaDedos.compare("para-dentro") == 0) {
                return "Ori_11";
            }  
        }
    }
    if (orientacao.compare("paralelo-ao-corpo") == 0) {
        if (direcaoPalmaMao.compare("para-frente") == 0) {
            if (orientacaoPontaDedos.compare("para-cima") == 0) {
                return "Ori_3";
            }
            if (orientacaoPontaDedos.compare("para-baixo") == 0) { //v
                return "Ori_9";
            }
        }
        if (direcaoPalmaMao.compare("para-dentro") == 0) {
            if (orientacaoPontaDedos.compare("para-cima") == 0) {
                return "Ori_2";
            }
            if (orientacaoPontaDedos.compare("para-baixo") == 0) {
                return "Ori_8";
            }
        }
        if (direcaoPalmaMao.compare("para-tras") == 0) {
            if (orientacaoPontaDedos.compare("para-cima") == 0) {
                return "Ori_1";
            }
            if (orientacaoPontaDedos.compare("para-baixo") == 0) {
                return "Ori_7";
            }
        }

    }
}

string OrientacaoMao::retornaStringCorrespondenteAOrientacao(string orientacao) {

   if (orientacao.compare("paralela-corpo-palma-tras-ponta-dedos-cima") == 0) {
        return "Ori_1";
    } else if (orientacao.compare("paralela-corpo-palma-tras-ponta-dedos-baixo") == 0) {
        return "Ori_7";
    } else if (orientacao.compare("paralela-corpo-palma-dentro-ponta-dedos-cima") == 0) {
        return "Ori_2";
    } else if (orientacao.compare("paralela-corpo-palma-dentro-ponta-dedos-baixo") == 0) {
        return "Ori_8";
    } else if (orientacao.compare("paralela-corpo-palma-frente-ponta-dedos-cima") == 0) {
        return "Ori_3";
    } else if (orientacao.compare("paralela-corpo-palma-frente-ponta-dedos-baixo") == 0) {
        return "Ori_9";
    } else if (orientacao.compare("paralela-solo-palma-baixo-ponta-dedos-frente") == 0) {
        return "Ori_4";
    } else if (orientacao.compare("paralela-solo-palma-baixo-ponta-dedos-dentro") == 0) {
        return "Ori_10";
    } else if (orientacao.compare("paralela-solo-palma-dentro-ponta-dedos-frente") == 0) {
        return "Ori_5";
    } else if (orientacao.compare("paralela-solo-palma-cima-ponta-dedos-frente") == 0) {
        return "Ori_6";
    } else if (orientacao.compare("paralela-solo-palma-cima-ponta-dentro") == 0) {
        return "Ori_12";
    }else
        return "Ori_11"; //paralela-solo-palma-dentro-ponta-dedos-dentro
}

OrientacaoMao::~OrientacaoMao() {
}

