#include "jsocket.h"
#include "jdatagramsocket.h"

#include <iostream>
#include <stdexcept>

using namespace jsocket;

int main() {
	char *receive = new char[100+1];
	
	try {
		ServerSocket server(3200);

		Socket *client;

		client = server.Accept();
		
		if (client != NULL) {
			do {
				client->Receive(receive, 100);
				// client->Send(receive, 100);
	
				receive[100] = '\0';
			
				std::cout << receive << std::endl;
			} while (true);
		}
		
		client->Close();
	} catch (std::runtime_error &e) {
		std::cout << "error " << e.what() << std::endl;
	}

	return 0;
}
